Subject: Re: [bitcoin-dev] bip48 proposal

From: dentondevelopment <[email-masked]>
Date: Wed, 24 Feb 2021 14:02:00 +0000

Hello all,

Just wanted to give an update on progress for the "bip48" proposal.

There was some discussion on Twitter between a few multi-sig wallet devs: https://twitter.com/fullynoded/status/1339374947228008448?s=21

A few key points were brought up:

1. We should not define a `script_type` as a path level

The explicit purpose of this BIP is to define an already existing standard that is used in practice across multi-sig wallets. In order to do that we must define a script_type in the path otherwise "loss of funds" could occur and backwards compatibility broken.

2. Another point brought up was that no-one uses the legacy derivation path m/48'/0'/0'/1', in practice all "legacy" p2sh multi-sig wallets use bip45.

I agree and have removed all references to legacy p2sh derivations in the proposed bip.

3. We could possibly include a defined "wild card" in the script_type level to define any future address types (e.g. taproot)

I agree this could be useful and think Ben Kaufman's suggestion of using m/48'/0'/0'/1' for this purpose makes sense, however I also think a future multi-sig standard for new address types may well be suited for a different BIP which could also address concern #1 around including `script_type` at all.

Therefore I have not yet added any mention of "wild card" in the proposed bip but kept strictly to p2sh-p2wsh and p2wsh derivations as used in modern day wallets.

I have create a PR https://github.com/bitcoin/bips/pull/1072 so that anyone may easily comment on it and any concerns can be raised.

I think the community needs this and it is well over due.  I have gotten positive feedback and support from other devs.

Feedback welcome.

Cheers,
Fontaine

Sent with ProtonMail Secure Email.

‐‐‐‐‐‐‐ Original Message ‐‐‐‐‐‐‐
On Friday, December 18, 2020 12:08 PM, Luke Dashjr <[email-masked]> wrote:

> Thanks for explaining where instructions are lacking.
>
> How does this look?
> https://github.com/bitcoin/bips/pull/1046/files
>
> On Friday 18 December 2020 01:44:27 dentondevelopment wrote:
>
> > Hi Luke,
> > It looks to have the same motivations and be compatible with
> > https://github.com/bitcoin/bips/pull/253 (if I am reading it correctly).
> > The only guidance I have on proposing a bip is what is on the readme
> > https://github.com/bitcoin/bips/blob/master/README.mediawiki
> > 48 would be fitting if it is unused.
> > This is still very much a work in progress and there does seem to be
> > community support.
> > Pavol and others have shared relevant info/suggestions which I will be
> > using to update the proposal.
> > Will share again here when the next draft is ready.
> > Many thanks,
> > Fontaine
> > Sent with ProtonMail Secure Email.
> > ‐‐‐‐‐‐‐ Original Message ‐‐‐‐‐‐‐
> > On Thursday, December 17, 2020 1:16 AM, Luke Dashjr [email-masked] wrote:
> >
> > > BIP number 48 has not been assigned. Do not self-assign BIP numbers.
> > > Is this intended to be compatible with
> > > https://github.com/bitcoin/bips/pull/253 ?
> > > Luke
> > > On Wednesday 16 December 2020 14:10:28 dentondevelopment via bitcoin-dev
> > > wrote:
> > >
> > > > Here is the repo instead of a static link:
> > > > https://github.com/Fonta1n3/bips/blob/master/bip-0048.mediawiki
> > > > Fontaine
> > > > Sent with ProtonMail Secure Email.
> > > > ‐‐‐‐‐‐‐ Original Message ‐‐‐‐‐‐‐
> > > > On Wednesday, December 16, 2020 8:43 PM, dentondevelopment via
> > > > bitcoin-dev
> > >
> > > [email-masked] wrote:
> > >
> > > > > Hello,
> > > > > I would like to propose bip48 (taking bip44 as inspiration), with the
> > > > > purpose of documenting modern multi-sig derivations.
> > > > > Please see a rough draft of the proposed bip attached, comments/input
> > > > > welcome.
> > > > > Regards,
> > > > > Fontaine